using System;
using System.Windows.Forms;

namespace Luminance_value_CSV_output
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        private int intsldZoom;
        private void Form1_Load(object sender, EventArgs e)
        {

            icImagingControl1.MouseWheel += new System.Windows.Forms.MouseEventHandler(this.icImagingControl1_MouseWheel);

            // foCXݒ_CAO\B
            if (!icImagingControl1.LoadShowSaveDeviceState("lastSelectedDeviceState.xml"))
            {
                MessageBox.Show("No device was selected.", this.Text, MessageBoxButtons.OK, MessageBoxIcon.Information);
                this.Close();
                return;
            }

            //J[tH[}bgɂĎgpł{^L/
            cmdY16.Enabled = icImagingControl1.VideoFormat.StartsWith("Y16");
            cmdRGB32.Enabled = icImagingControl1.VideoFormat.StartsWith("RGB32");
            cmdRGB64.Enabled = icImagingControl1.VideoFormat.StartsWith("RGB64");


            icImagingControl1.OverlayBitmapPosition = TIS.Imaging.PathPositions.None;
            //\TCYύX̂falseɂ
            icImagingControl1.LiveDisplayDefault = false;
            icImagingControl1.LiveStart();
            //AXyNgŒ
            intsldZoom = icImagingControl1.Height * 100 / icImagingControl1.LiveDisplayOutputHeight;
            icImagingControl1.LiveDisplayZoomFactor = (float)intsldZoom / 100f;

            //ENbN\
            this.ContextMenuStrip = this.contextMenuStrip1;
        }


        private void icImagingControl1_MouseWheel(object sender, MouseEventArgs e)
        {
            //Ctrl L[ꂽԂł邩mF
            if ((Control.ModifierKeys & Keys.Control) == Keys.Control)
            {
                if (icImagingControl1.LiveDisplayDefault == false)
                {
                    int value = (e.Delta * SystemInformation.MouseWheelScrollLines / 360) + intsldZoom;
                    if (80 >= value && 1 <= value)
                    {
                        intsldZoom = value;
                        icImagingControl1.LiveDisplayZoomFactor = (float)intsldZoom / 10.0f;

                    }
                }
            }

        }

        private TIS.Imaging.IFrameQueueBuffer GrabImage(Guid colorFormat)
        {
            bool wasLive = icImagingControl1.LiveVideoRunning;
            icImagingControl1.LiveStop();

            TIS.Imaging.BaseSink oldSink = icImagingControl1.Sink;

            TIS.Imaging.FrameSnapSink sink = new TIS.Imaging.FrameSnapSink(new TIS.Imaging.FrameType(colorFormat));

            icImagingControl1.Sink = sink;

            try
            {
                icImagingControl1.LiveStart();
            }
            catch (TIS.Imaging.ICException ex)
            {
                MessageBox.Show(ex.Message);
                icImagingControl1.Sink = oldSink;
                return null;
            }

            TIS.Imaging.IFrameQueueBuffer rval = null;

            try
            {
                rval = sink.SnapSingle(TimeSpan.FromSeconds(1));
            }
            catch (TIS.Imaging.ICException ex)
            {
                MessageBox.Show(ex.Message);
            }

            icImagingControl1.LiveStop();

            icImagingControl1.Sink = oldSink;

            if (wasLive)
                icImagingControl1.LiveStart();

            return rval;
        }

        class BufferAccessHelper
        {
            TIS.Imaging.IFrameQueueBuffer buf;

            public BufferAccessHelper(TIS.Imaging.IFrameQueueBuffer buf)
            {
                this.buf = buf;
            }

            public unsafe byte this[int x, int y]
            {
                get
                {
                    byte* ptr = buf.Ptr + y * buf.FrameType.BytesPerLine + x;
                    return *ptr;
                }
                set
                {
                    byte* ptr = buf.Ptr + y * buf.FrameType.BytesPerLine + x;
                    *ptr = value;
                }
            }
        }



        private void cmdY800_Click(object sender, EventArgs e)
        {
            TIS.Imaging.IFrameQueueBuffer frame = GrabImage(TIS.Imaging.MediaSubtypes.Y800);
            if (frame == null) return;

            BufferAccessHelper buf = new BufferAccessHelper(frame);

            Cursor.Current = Cursors.WaitCursor;
            txtOutput.Text = "";
            Refresh();


            string strFormat = frame.FrameType.Name;
            TIS.Imaging.FrameExtensions.SaveAsBitmap(frame, "Y800.bmp");


            string strBuf = "";


            using (System.IO.StreamWriter writer = new System.IO.StreamWriter(@"Output" + strFormat + ".csv", false))
            {
                for (int i = 0; i < frame.FrameType.Height; i++)
                {
                    strBuf = "";
                    for (int j = 0; j < frame.FrameType.Width; j++)
                    {
                        strBuf += "Y800(";
                        strBuf += buf[j, i] + "),";
                    }
                    writer.WriteLine(strBuf);
                }

            }
            //ɖ߂
            Cursor.Current = Cursors.Default;
            txtOutput.Text = "I";

        }


        private void cmdRGB24_Click(object sender, EventArgs e)
        {
            TIS.Imaging.IFrameQueueBuffer frame = GrabImage(TIS.Imaging.MediaSubtypes.RGB24);
            if (frame == null) return;

            BufferAccessHelper buf = new BufferAccessHelper(frame);


            Cursor.Current = Cursors.WaitCursor;
            txtOutput.Text = "";
            Refresh();

            string strFormat = frame.FrameType.Name;



            TIS.Imaging.FrameExtensions.SaveAsBitmap(frame, "RGB24.bmp");


            string strBuf = "";

            using (System.IO.StreamWriter writer = new System.IO.StreamWriter(@"Output" + strFormat + ".csv", false))
            {
                for (int i = frame.FrameType.Height - 1; i >= 0; i--)
                {
                    strBuf = "";
                    for (int j = 0; j < frame.FrameType.Width; j++)
                    {
                        strBuf += "RGB24(";
                        strBuf += buf[j * 3 + 2, i] + "/";
                        strBuf += buf[j * 3 + 1, i] + "/";
                        strBuf += buf[j * 3 + 0, i] + "),";
                    }
                    writer.WriteLine(strBuf);
                }
            }
            //ɖ߂
            Cursor.Current = Cursors.Default;
            txtOutput.Text = "I";


        }

        private void cmdRGB32_Click(object sender, EventArgs e)
        {
            TIS.Imaging.IFrameQueueBuffer frame = GrabImage(TIS.Imaging.MediaSubtypes.RGB32);
            if (frame == null) return;

            BufferAccessHelper buf = new BufferAccessHelper(frame);


            Cursor.Current = Cursors.WaitCursor;
            txtOutput.Text = "";
            Refresh();

            string strFormat = frame.FrameType.Name;

            TIS.Imaging.FrameExtensions.SaveAsBitmap(frame, "RGB32.bmp");


            string strBuf = "";

            using (System.IO.StreamWriter writer = new System.IO.StreamWriter(@"Output" + strFormat + ".csv", false))
            {
                for (int i = frame.FrameType.Height - 1; i >= 0; i--)
                {
                    strBuf = "";
                    for (int j = 0; j < frame.FrameType.Width; j++)
                    {
                        strBuf += "RGB32(";
                        strBuf += buf[j * 4 + 2, i] + "/";
                        strBuf += buf[j * 4 + 1, i] + "/";
                        strBuf += buf[j * 4 + 0, i] + "),";
                    }
                    writer.WriteLine(strBuf);
                }
            }

            //ɖ߂
            Cursor.Current = Cursors.Default;
            txtOutput.Text = "I";
        }


        private unsafe UInt16 ReadY16(TIS.Imaging.IFrameQueueBuffer buf, int row, int col)
        {

            int offset = row * buf.FrameType.BytesPerLine + col * 2;

            return (UInt16)System.Runtime.InteropServices.Marshal.ReadInt16(new IntPtr(buf.Ptr), offset);
        }
 


        private unsafe void WriteY16(TIS.Imaging.IFrameQueueBuffer buf, int row, int col, UInt16 value)
        {
            int offset = row * buf.FrameType.BytesPerLine + col * 2;

            System.Runtime.InteropServices.Marshal.WriteInt16(new IntPtr(buf.Ptr), offset, (short)value);
        }


        private void cmdY16_Click(object sender, EventArgs e)
        {
            TIS.Imaging.IFrameQueueBuffer buf = GrabImage(TIS.Imaging.MediaSubtypes.Y16);
            if (buf == null) return;

            //ҋ@
            Cursor.Current = Cursors.WaitCursor;
            txtOutput.Text = "";
            Refresh();

            string strFormat = buf.FrameType.Name;
            TIS.Imaging.FrameExtensions.SaveAsTiff(buf, "y16.tiff");
            string strBuf = "";


            using (System.IO.StreamWriter writer = new System.IO.StreamWriter(@"Output" + strFormat + ".csv", false))
            {
                for (int i = 0; i < buf.FrameType.Height; i++)
                {
                    strBuf = "";
                    for (int j = 0; j < buf.FrameType.Width; j++)
                    {
                        strBuf += "Y16(";
                        strBuf += ReadY16(buf, i, j) + "),";

                    }
                    writer.WriteLine(strBuf);
                }
            }

            //ɖ߂
            Cursor.Current = Cursors.Default;
            txtOutput.Text = "I";

        }


  
        private unsafe UInt16 ReadRGB64(TIS.Imaging.IFrameQueueBuffer buf, int row, int col)
        {
            int offset = (row * buf.FrameType.BytesPerLine + col * 2);

            return (UInt16)System.Runtime.InteropServices.Marshal.ReadInt16(new IntPtr(buf.Ptr), offset);
        }
 
        private unsafe void WriteRGB64(TIS.Imaging.IFrameQueueBuffer buf, int row, int col, UInt16 value)
        {
            int offset = row * buf.FrameType.BytesPerLine + col * 2;
            System.Runtime.InteropServices.Marshal.WriteInt16(new IntPtr(buf.Ptr), offset, (short)value);
        }

        private void cmdRGB64_Click(object sender, EventArgs e)
        {
            TIS.Imaging.IFrameQueueBuffer buf = GrabImage(TIS.Imaging.MediaSubtypes.RGB64);
            if (buf == null) return;

            Cursor.Current = Cursors.WaitCursor;
            txtOutput.Text = "";
            Refresh();

            string strFormat = buf.FrameType.Name;
            TIS.Imaging.FrameExtensions.SaveAsTiff(buf, "RGB64.tiff");
            string strBuf = "";

            using (System.IO.StreamWriter writer = new System.IO.StreamWriter(@"Output" + strFormat + ".csv", false))
            {
                for (int i = buf.FrameType.Height - 1; i >= 0; i--)
                {
                    strBuf = "";
                    for (int j = 0; j < buf.FrameType.Width; j++)
                    {
                        strBuf += "RGB64(";
                        strBuf += ReadRGB64(buf, i, j * 3 + 2) + "/";
                        strBuf += ReadRGB64(buf, i, j * 3 + 1) + "/";
                        strBuf += ReadRGB64(buf, i, j * 3 + 0) + "),";
                    }

                    writer.WriteLine(strBuf);
                }
            }
            //ɖ߂
            Cursor.Current = Cursors.Default;
            txtOutput.Text = "I";
        }

        private void foCXIToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (icImagingControl1.DeviceValid) icImagingControl1.LiveStop();

            icImagingControl1.ShowDeviceSettingsDialog();


            icImagingControl1.LiveDisplayDefault = false;
            icImagingControl1.LiveDisplaySize = icImagingControl1.VideoFormatCurrent.Size;

            if (icImagingControl1.DeviceValid) icImagingControl1.LiveStart();

            //ʂɍ킹TCYɉʕ\
            float aspectRatio = icImagingControl1.Height * 100 / icImagingControl1.LiveDisplayOutputHeight;
            icImagingControl1.LiveDisplayZoomFactor = aspectRatio / 100f;
            cmdY16.Enabled = icImagingControl1.VideoFormat.StartsWith("Y16");
            cmdRGB64.Enabled = icImagingControl1.VideoFormat.StartsWith("RGB64");
            cmdRGB32.Enabled = icImagingControl1.VideoFormat.StartsWith("RGB32");
        }

        private void vpeBToolStripMenuItem_Click(object sender, EventArgs e)
        {
            icImagingControl1.ShowPropertyDialog();
        }

        private void IToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Close();
        }
    }
}